#/****************************************************************
#*               COPYRIGHT (C) NEC CORPORATION 2017-2021         *
#*                                                               *
#*    ALL RIGHTS RESERVED BY NEC CORPORATION. THIS PROGRAM MUST  *
#* BE USED SOLELY FOR THE PURPOSE FOR WHICH IT WAS FURNISHED BY  *
#* NEC CORPORATION.  NO PART OF THIS PROGRAM MAY BE REPRODUCED   *
#* OR DISCLOSED TO OTHERS,IN ANY FORM,WITHOUT THE PRIOR WRITTEN  *
#* PERMISSON OF NEC CORPORATION.                                 *
#*    USE OF COPYRIGHT NOTICE DOES NOT EVIDENCE PUBLICATION OF   *
#* THE PROGRAM.                                                  *
#*                                                               *
#*               NEC CONFIDENTIAL AND PROPRIENTARY               *
#****************************************************************/

import sys
import redfish
import json
import os
import pprint

from redfish import AuthMethod, redfish_client
from redfish.rest.v1 import SecurityStateError, InvalidCredentialsError
from redfish.hpilo.rishpilo import HpIloChifPacketExchangeError, HpIloInitialError

#import gc

REST_OBJ = None

def init(iLO_host,login_account,login_password):
    try:
        global REST_OBJ
        REST_OBJ = redfish.redfish_client(base_url=iLO_host,username=login_account, \
                          password=login_password, default_prefix="/redfish/v1")
        if REST_OBJ is not None:
           REST_OBJ.login(auth="session")
           return 200

    except (InvalidCredentialsError, SecurityStateError, HpIloInitialError) as e:
        return 401
    except HpIloChifPacketExchangeError as e:
        return 10001

    except:
        pass


def get(uri):
    try:
        global REST_OBJ
        response = REST_OBJ.get(uri, None)
        enc_data = response.read
        del response
        return enc_data
    except (InvalidCredentialsError, SecurityStateError, HpIloInitialError) as e:
        return 401
    except HpIloChifPacketExchangeError as e:
        return 10001
    except:
        pass

def close():
    try:
        global REST_OBJ
        if REST_OBJ is not None:
            REST_OBJ.logout()
        del REST_OBJ
        REST_OBJ = None
        return
    except:
        pass

